package com.example.ellegadodepintia.exploradoresDePintia.model.eventoFactory

import com.example.ellegadodepintia.R
import com.example.ellegadodepintia.exploradoresDePintia.model.Atributo
import com.example.ellegadodepintia.exploradoresDePintia.model.Opcion
import com.example.ellegadodepintia.exploradoresDePintia.model.efecto.EfectoIgnorar
import com.example.ellegadodepintia.exploradoresDePintia.model.efecto.EfectoUtilizarObjetoUtil

class DesenterrarFactory : EventoFactory {
    private val desenterrarMap = mapOf(
        "¡Has encontrado un antiguo yacimiento arqueológico! Aquí se esconden reliquias misteriosas esperando ser desenterradas. ¿Qué secretos del pasado descubrirás?" to Pair(
            R.drawable.asi_exploradores_desenterrar, listOf(
                Opcion(
                    descripcion = "Desenterrar",
                    atributoRequerida = Atributo.Nula,
                    EfectoUtilizarObjetoUtil(
                        "Pala Vaccea"
                    )
                ), Opcion(
                    descripcion = "Ignorar",
                    atributoRequerida = Atributo.Nula,
                    EfectoIgnorar(100)
                )
            )
        ),
    )

    override fun generarDescripcion(): String {
        return desenterrarMap.keys.random()
    }

    override fun generarOpciones(descripcion: String): MutableList<Opcion> {
        return desenterrarMap[descripcion]?.second?.shuffled()?.take(4)?.toMutableList()
            ?: mutableListOf()
    }

    override fun generarImagen(descripcion: String): Int {
        return desenterrarMap[descripcion]?.first!!
    }

    override fun generarEvento(): EventoDesenterrar {
        val descripcion = generarDescripcion()
        return EventoDesenterrar(
            descripcion = descripcion,
            dificultad = 0,
            opciones = generarOpciones(descripcion),
            imagen = generarImagen(descripcion),
            resistenciaMax = (2..8).random(),
            finalizado = false
        )
    }
}